<p align='center'>
  <img alt="GitHub" src="https://img.shields.io/packagist/stars/KieSun/fucking-frontend">
  <img alt="GitHub" src="https://img.shields.io/github/license/KieSun/fucking-frontend?label=License">
  <img src="https://visitor-badge.laobi.icu/badge?page_id=KieSun.fucking-frontend" alt="visitor badge"/>  
</p>

干爆前端。一网打尽前端学习、进阶、面试等各类内容，帮助大家一年内拿到期望的 offer！大家可以关注【[公众号](#个人信息)】获取最新内容或者加我【[微信](#个人信息)】提意见（别忘了点个 Star 咯）。

**本仓库欢迎各位读者提交你认为不错的内容，直接开 PR 或者 Issue 都可。**

## 这是什么？

这是一份笔者从自学前端逐步成长为大厂基架组资深前端开发所沉淀下来的资料，其中包含了前端体系化学习、进阶、面试等内容。

**此资料适用于初中级进阶、高级查漏补缺。**

## 如何使用

前端学习路径笔者会以计划的方式呈现，从基础到进阶内容都会涉及，并且会附带上笔者的一些解释以便读者们将知识连贯起来，从而建立自己的知识体系而不是单独记忆松散的知识点。

**推荐大家 Star 并 Fork 本项目（点击仓库顶部右上角按钮），然后 `git clone` 到本地后从上至下逐步完成学习计划。**

![5Kcgzt](https://yck-1254263422.file.myqcloud.com/uPic/5Kcgzt.jpeg)

当然除了前端学习路径，笔者还提供了热门技术原理解析、工程化体系学习、Github 上的优秀资料等内容供大家自行选择，读者们可以挑选感兴趣的内容自行学习。

## 目录
- [学习路径](#学习路径)
  - [前端核心知识点](#前端核心知识点)
- [十五万字面试资料](#十五万字面试资料)
- [前端工程化文章](#前端工程化文章)
- [React 原理](#react-原理)
- [前端进阶文章](#前端进阶文章)
- [更多文章](#更多文章)
- [个人信息](#个人信息)

## 学习路径

前端知识点很多这是公认的事情，但是我们确实没必要把所有知识都去学习，那样只会贪多嚼不烂。我们能把核心知识点、热门技术以及工作中需要用到的知识学好就已经能打败大部分前端工程师了，剩下的大家可以自行选择学习内容。

接下来的内容笔者会按照优先级高低来排布学习路径的目录，大家只需从上到下顺序学习即可。

> 为了保证大家学到的知识是正确的，下文中的文档资料笔者都使用了英文版本。因为在审核资料的过程中笔者发现不少中文文档都存在翻译错误或者过时的情况。

## 前端核心知识点

前端核心知识点分为三块，分别为 HTML、CSS、JS，其中最重要的当然是 JS 了。

如果你还是一位初学者，推荐先自行完整阅读一至二本书后再按照该计划学习。关于书籍笔者推荐以下两本：

- [JavaScript高级程序设计（第4版）](https://book.douban.com/subject/35175321/)
- [JavaScript忍者秘籍（第2版）](https://book.douban.com/subject/30143702/)

## JS

### 数据类型

JS 数据类型分为两大类及八种数据类型，注意别漏了 ES6 新增的 `bigint`。

- [ ] 文档：
  - [ ] [JavaScript 数据类型和数据结构](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures)

## 十五万字面试资料

[在线阅读](https://yuchengkai.cn/home/)

- [解决 90% 的大厂基础面试题](https://mp.weixin.qq.com/s?__biz=MzUyNDYxNDAyMg==&mid=2247488553&idx=1&sn=62d8a99b5554751221b45b3c411ad325)
- [解决 90% 的大厂前端网络面试题](https://mp.weixin.qq.com/s?__biz=MzUyNDYxNDAyMg==&amp;mid=2247488796&amp;idx=1&amp;sn=dec4fdb3e596ad87b02419f69c174113)

## 前端工程化文章

- [这才是你需要了解的性能优化呀！](https://mp.weixin.qq.com/s?__biz=MzUyNDYxNDAyMg==&amp;mid=2247489161&amp;idx=1&amp;sn=f029ea01370364f49fe61451b2d247ff)
- [绝了，没想到一个 source map 居然涉及到那么多知识盲区](https://mp.weixin.qq.com/s?__biz=MzUyNDYxNDAyMg==&amp;mid=2247488867&amp;idx=1&amp;sn=cac0ae95c560cca820658a8c3af3f8e5)
- [揭秘自动化部署系统的核心原理](https://mp.weixin.qq.com/s?__biz=MzUyNDYxNDAyMg==&amp;mid=2247488166&amp;idx=1&amp;sn=f62669f6c9331c95badbef2815a8d1b5)
- [你知道 monorepo 居然有那么多坑么？](https://mp.weixin.qq.com/s?__biz=MzUyNDYxNDAyMg==&amp;mid=2247488604&amp;idx=1&amp;sn=6ded0f2ddaedb71bd5d12890cf462726)
- [从零打造性能检测库](https://mp.weixin.qq.com/s?__biz=MzUyNDYxNDAyMg==&amp;mid=2247487811&amp;idx=2&amp;sn=40d02e839fb5400c5b82858d422fb738)
- [还在看那些老掉牙的性能优化文章么？这些最新性能指标了解下](https://mp.weixin.qq.com/s?__biz=MzUyNDYxNDAyMg==&amp;mid=2247486142&amp;idx=1&amp;sn=b75b87a109c28cc6c32046d0fb234aab)

## React 原理

[在线阅读](https://github.com/KieSun/react-interpretation)，另外笔者最近也在准备更新这部分内容，有兴趣的读者可以持续关注。

## 前端进阶文章

- [这些 JS 新语法有点东西啊！](https://mp.weixin.qq.com/s?__biz=MzUyNDYxNDAyMg==&amp;mid=2247489249&amp;idx=1&amp;sn=9a3cedafd021afe8ed3ef81bcd0583c2)
- [这个 React 小细节居然很多人都写错了？](https://mp.weixin.qq.com/s?__biz=MzUyNDYxNDAyMg==&amp;mid=2247489054&amp;idx=1&amp;sn=f025d5dfd81656e5cffd7eb598b0954b)
- [反直觉！大部分人并不知道浏览器到底是如何下载资源的](https://mp.weixin.qq.com/s?__biz=MzUyNDYxNDAyMg==&amp;mid=2247488074&amp;idx=1&amp;sn=21dc9b18cf52d875dec5dc38b34900fe)
- [好家伙，这些写 CSS 的新姿势你还不知道？](https://mp.weixin.qq.com/s?__biz=MzUyNDYxNDAyMg==&amp;mid=2247488007&amp;idx=1&amp;sn=8578ba4a4278de3286feeb18535c75a2)
- [这个异步问题你肯定遇到过，但是会解决的并不多](https://mp.weixin.qq.com/s?__biz=MzUyNDYxNDAyMg==&amp;mid=2247487988&amp;idx=1&amp;sn=6b56888236e0cc8b59e7bf63ff882a21)
- [前端前沿观察，Cookie 居然可以这样整了](https://mp.weixin.qq.com/s?__biz=MzUyNDYxNDAyMg==&amp;mid=2247486890&amp;idx=1&amp;sn=3f92d1290e62549731b9d840aed68cc9)
- [Promise 你可能真的还没用明白（续集进阶版）](https://mp.weixin.qq.com/s?__biz=MzUyNDYxNDAyMg==&amp;mid=2247486584&amp;idx=1&amp;sn=26c5d27b34cc98f952715581b8c74027)

## 更多文章

因为笔者文章实在太多，足足已经写了 150 篇+ 原创，更多文章欢迎大家到【[公众号](#个人信息)】里阅读。


## 个人信息

| 微信扫码关注公众号，订阅更多精彩内容                                                                 | 加笔者微信进群与大厂大佬讨论技术                                                                    |
| ---------------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------- |
| <img src="https://yck-1254263422.cos.ap-shanghai.myqcloud.com/20191220223702.jpeg" width="500px;" /> | <img src="https://yck-1254263422.cos.ap-shanghai.myqcloud.com/20191220224224.png" width="260px;" /> |
